<?php
/* Sandbox v0.5-1.0b
 * Copyright (c) 2006-2007
 * Sam O'Connor (Kiasyn) http://www.kiasyn.com
 *
 * Additions to Sandbox after 1.0:
 * Copyright (c) 2007-2010
 * Roger Libiez [Samson] http://www.iguanadons.net
 *
 * This software is provided 'as-is', without any express or implied warranty.
 * In no event will the authors be held liable for any damages arising from the
 * use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it freely,
 * subject to the following restrictions:
 *
 * 1. The origin of this software must not be misrepresented; you must not claim
 * that you wrote the original software. If you use this software in a product,
 * an acknowledgment in the product documentation is required.
 *
 * 2. Altered source versions must be plainly marked as such, and must not be
 * misrepresented as being the original software.
 *
 * 3. This notice may not be removed or altered from any source distribution.
 *
 * 4. You must make an effort to notify the author (Sam O'Connor) at the email
 * address sandbox@kiasyn.com if you plan on publicly distributing a derivative
 * of this software, whether by email, download or a form of disk/disc.
 *
 * Notifying Roger Libiez is not required but would still be appreciated :)
 */

if ( !defined('SANDBOX') ) {
	header('HTTP/1.0 403 Forbidden');
	die;
}

class database
{
	var $host = null;
	var $user = null;
	var $pass = null;
	var $db = null;
	var $dbconn = null;
	var $queries = 0;
	var $queries_exec = 0;
	var $query_time = 0;

	function database( $host, $user, $pass, $db)
	{
		$this->host = $host;
		$this->user = $user;
		$this->pass = $pass;
		$this->db = $db;
		return $this->open( );
	}

	function open()
	{
		if ( ( $this->dbconn = mysqli_connect( $this->host, $this->user, $this->pass ) ) == null )
			die('MySQL error: ' . mysqli_error( $this->dbconn ) );
		if ( !mysqli_select_db( $this->dbconn, $this->db ) )
			die('MySQL error: ' . mysqli_error( $this->dbconn ) );
	}

	function query( $query, $admin = false )
	{
		$time_now   = explode(' ', microtime());
		$time_start = $time_now[1] + $time_now[0];

		if( $admin )
			$result = mysqli_query( $this->dbconn, $query ) or null;
		else
			$result = mysqli_query( $this->dbconn, $query ) or
				error(SANDBOX_QUERY_ERROR, mysqli_error($this->dbconn), $query, mysqli_errno($this->dbconn));
		$this->queries++;

		$time_now  = explode(' ', microtime());
		$time_exec = round($time_now[1] + $time_now[0] - $time_start, 5);
		$this->query_time = $time_exec;
		$this->queries_exec += $time_exec;

		return $result;
	}

	function row( $result )
	{
		return mysqli_fetch_row( $result );
	}

	function assoc( $result )
	{
		return mysqli_fetch_assoc( $result );
	}

	function quick_query( $query )
	{
		return $this->assoc( $this->query( $query ) );
	}

	function num_rows( $result )
	{
		return mysqli_num_rows( $result );
	}

	function row_exists( $query )
	{
		$result = $this->query( $query );
		return $this->num_rows( $result ) > 0;
	}

	function insert_id()
	{
		return mysqli_insert_id( $this->dbconn );
	}

	function escape( $str )
	{
		return mysqli_real_escape_string( $this->dbconn, $str );
	}

	function error()
	{
		return mysqli_error( $this->dbconn );
	}

	function close()
	{
		if ( $this->dbconn )
			mysqli_close( $this->dbconn );
	}
}
?>